=begin
#FreeClimb API

#FreeClimb is a cloud-based application programming interface (API) that puts the power of the Vail platform in your hands. FreeClimb simplifies the process of creating applications that can use a full range of telephony features without requiring specialized or on-site telephony equipment. Using the FreeClimb REST API to write applications is easy! You have the option to use the language of your choice or hit the API directly. Your application can execute a command by issuing a RESTful request to the FreeClimb API. The base URL to send HTTP requests to the FreeClimb REST API is: /apiserver. FreeClimb authenticates and processes your request.

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0-SNAPSHOT

=end

# Common files
require 'freeclimb/api_client'
require 'freeclimb/api_error'
require 'freeclimb/version'
require 'freeclimb/configuration'
require 'freeclimb/utils'
require 'freeclimb/models/percl_command'

# Models
require 'freeclimb/models/account_request'
require 'freeclimb/models/account_result'
require 'freeclimb/models/account_result_all_of'
require 'freeclimb/models/add_to_conference'
require 'freeclimb/models/add_to_conference_all_of'
require 'freeclimb/models/application_list'
require 'freeclimb/models/application_list_all_of'
require 'freeclimb/models/application_request'
require 'freeclimb/models/application_result'
require 'freeclimb/models/application_result_all_of'
require 'freeclimb/models/available_number'
require 'freeclimb/models/available_number_list'
require 'freeclimb/models/available_number_list_all_of'
require 'freeclimb/models/buy_incoming_number_request'
require 'freeclimb/models/call_list'
require 'freeclimb/models/call_list_all_of'
require 'freeclimb/models/call_result'
require 'freeclimb/models/call_result_all_of'
require 'freeclimb/models/conference_list'
require 'freeclimb/models/conference_list_all_of'
require 'freeclimb/models/conference_participant_list'
require 'freeclimb/models/conference_participant_list_all_of'
require 'freeclimb/models/conference_participant_result'
require 'freeclimb/models/conference_participant_result_all_of'
require 'freeclimb/models/conference_result'
require 'freeclimb/models/conference_result_all_of'
require 'freeclimb/models/create_conference'
require 'freeclimb/models/create_conference_all_of'
require 'freeclimb/models/create_conference_request'
require 'freeclimb/models/dequeue'
require 'freeclimb/models/enqueue'
require 'freeclimb/models/enqueue_all_of'
require 'freeclimb/models/filter_logs_request'
require 'freeclimb/models/get_digits'
require 'freeclimb/models/get_digits_all_of'
require 'freeclimb/models/get_speech'
require 'freeclimb/models/get_speech_all_of'
require 'freeclimb/models/hangup'
require 'freeclimb/models/hangup_all_of'
require 'freeclimb/models/incoming_number_list'
require 'freeclimb/models/incoming_number_list_all_of'
require 'freeclimb/models/incoming_number_request'
require 'freeclimb/models/incoming_number_result'
require 'freeclimb/models/incoming_number_result_all_of'
require 'freeclimb/models/log_list'
require 'freeclimb/models/log_list_all_of'
require 'freeclimb/models/log_result'
require 'freeclimb/models/make_call_request'
require 'freeclimb/models/message_request'
require 'freeclimb/models/message_request_all_of'
require 'freeclimb/models/message_result'
require 'freeclimb/models/message_result_all_of'
require 'freeclimb/models/messages_list'
require 'freeclimb/models/messages_list_all_of'
require 'freeclimb/models/mutable_resource_model'
require 'freeclimb/models/out_dial'
require 'freeclimb/models/out_dial_all_of'
require 'freeclimb/models/pagination_model'
require 'freeclimb/models/pause'
require 'freeclimb/models/pause_all_of'
require 'freeclimb/models/percl_command'
require 'freeclimb/models/percl_script'
require 'freeclimb/models/play'
require 'freeclimb/models/play_all_of'
require 'freeclimb/models/play_early_media'
require 'freeclimb/models/play_early_media_all_of'
require 'freeclimb/models/queue_list'
require 'freeclimb/models/queue_list_all_of'
require 'freeclimb/models/queue_member'
require 'freeclimb/models/queue_member_list'
require 'freeclimb/models/queue_member_list_all_of'
require 'freeclimb/models/queue_request'
require 'freeclimb/models/queue_result'
require 'freeclimb/models/queue_result_all_of'
require 'freeclimb/models/record_utterance'
require 'freeclimb/models/record_utterance_all_of'
require 'freeclimb/models/recording_list'
require 'freeclimb/models/recording_list_all_of'
require 'freeclimb/models/recording_result'
require 'freeclimb/models/recording_result_all_of'
require 'freeclimb/models/redirect'
require 'freeclimb/models/redirect_all_of'
require 'freeclimb/models/reject'
require 'freeclimb/models/reject_all_of'
require 'freeclimb/models/remove_from_conference'
require 'freeclimb/models/remove_from_conference_all_of'
require 'freeclimb/models/say'
require 'freeclimb/models/say_all_of'
require 'freeclimb/models/send_digits'
require 'freeclimb/models/send_digits_all_of'
require 'freeclimb/models/set_listen'
require 'freeclimb/models/set_listen_all_of'
require 'freeclimb/models/set_talk'
require 'freeclimb/models/set_talk_all_of'
require 'freeclimb/models/sms'
require 'freeclimb/models/sms_all_of'
require 'freeclimb/models/start_record_call'
require 'freeclimb/models/terminate_conference'
require 'freeclimb/models/terminate_conference_all_of'
require 'freeclimb/models/update_call_request'
require 'freeclimb/models/update_conference_participant_request'
require 'freeclimb/models/update_conference_request'

# APIs
require 'freeclimb/api/default_api'

module Freeclimb
  class << self
    # Customize default settings for the SDK using block.
    #   Freeclimb.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end

  def self.percl_list_to_hash(percl_list)
    percl_list_hash = []
    percl_list.each_with_index do | command, index |
      class_name = command.class.name.split('::').last
      percl_hash = Hash.new
      if command.respond_to?(:prompts) && command.prompts != nil && command.prompts.any?
        percl_hash[class_name] = to_hash_with_prompts(command)
      else
        percl_hash[class_name] = command.to_hash
      end
      percl_list_hash.push(percl_hash)
    end
    percl_list_hash
  end

  def self.to_hash_with_prompts(command)
    prompts_hash = percl_list_to_hash(command.prompts)
    command.prompts = nil
    hash = command.to_hash
    hash[:prompts] = prompts_hash
    hash
  end

  def self.percl_to_json(percl_script)
    percl_list_to_hash(percl_script.commands).to_json
  end
end
